

#if !defined __VGEV_MOUSE_H
#define __VGEV_MOUSE_H


#include "pstring.h"

#include "vissim.h"


#define VGEV_MOUSE_MODE_NULL     0
#define VGEV_MOUSE_MODE_RESET    1
#define VGEV_MOUSE_MODE_PICK     2
#define VGEV_MOUSE_MODE_AZRANGE  3
#define VGEV_MOUSE_MODE_ZOOM     4
#define VGEV_MOUSE_MODE_RECENTER 5
#define VGEV_MOUSE_MODE_LOS      6

#define PICK_RADIUS  7
#define MOUSE_MOVE   4

#define LEFTBUTTON   0
#define MIDDLEBUTTON 1
#define RIGHTBUTTON  2


class canvas;


/* **************************************************************
************************************************************** */
class mouse_handler_type {

   protected:
      int mouse_mode;
      int old_mode;
      double azimuth;
      
      canvas *parent;

      void left_pick(int x, int y, double lon, double lat);
      void left_release(iface *isim, int x, int y, double lon, double lat);
      void zoom(int x, int y);

      virtual void pick_platform(iface *isim, int x, int y, double lon, double lat);

   public:
      int enable, drawflag;
      vector2i box[2];
      vector2i mouse_pos;
      vector2i drag_coord;
      
      vector2d sbearlonlat, ebearlonlat;
      char bear_sreadout[MAXSTRLEN], bear_ereadout[MAXSTRLEN], bear_rangebear[MAXSTRLEN];
      
      mouse_handler_type();
      mouse_handler_type(canvas *x);
      virtual ~mouse_handler_type() {}

      void set_canvas(canvas *p) { parent = p; }
      
      void reset();
      void set_state(int state);
      int query_state() { return mouse_mode; }

      void event_motion(int x, int y, double lon, double lat);
      virtual void event_pick(int button, int x, int y, double lon, double lat);
      virtual void event_release(iface *isim, int button, int x, int y, double lon, double lat);
};


#include "vgev_draw.h"

#endif
